package basica;
import java.io.ByteArrayOutputStream;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.TargetDataLine;


public class CaptureThread extends Thread{
	//An arbitrary-size temporary holding
	// buffer
	byte tempBuffer[] = new byte[10000];
	ByteArrayOutputStream byteArrayOutputStream;
	boolean stopCapture;
	TargetDataLine targetDataLine;
	
	public CaptureThread(TargetDataLine tDL) {
		this.targetDataLine = tDL;
	}
	public void run(){
		byteArrayOutputStream =	new ByteArrayOutputStream();
		stopCapture = false;
		try{//Loop until stopCapture is set
			// by another thread that
			// services the Stop button.
			while(!stopCapture){
				//Read data from the internal
				// buffer of the data line.
				int cnt = targetDataLine.read(tempBuffer, 0, tempBuffer.length);
				if(cnt > 0){
					//Save data in output stream
					// object.
					byteArrayOutputStream.write(tempBuffer, 0, cnt);
				}//end if
			}//end while
			byteArrayOutputStream.close();

		}catch (Exception e) {
			System.out.println(e);
			System.exit(0);
		}//end catch
	}//end run
	public byte[] getTempBuffer() {
		return tempBuffer;
	}
	public void setTempBuffer(byte[] tempBuffer) {
		this.tempBuffer = tempBuffer;
	}
	public ByteArrayOutputStream getByteArrayOutputStream() {
		return byteArrayOutputStream;
	}
	public void setByteArrayOutputStream(ByteArrayOutputStream byteArrayOutputStream) {
		this.byteArrayOutputStream = byteArrayOutputStream;
	}
	public boolean isStopCapture() {
		return stopCapture;
	}
	public void setStopCapture(boolean stopCapture) {
		this.stopCapture = stopCapture;
	}
	public TargetDataLine getTargetDataLine() {
		return targetDataLine;
	}
	public void setTargetDataLine(TargetDataLine targetDataLine) {
		this.targetDataLine = targetDataLine;
	}
}//end inner class CaptureThread
//===================================//