package basica;
import java.nio.ByteBuffer;
import java.nio.IntBuffer;
import java.nio.LongBuffer;


public abstract class Packet {
	boolean[] flags;
	
	public abstract byte[] convertToByte();
	public abstract void bytesToPacket(byte[] pkt);

	public boolean[] getFlags() {
		return flags;
	}
	public void setFlags(boolean[] flags) {
		this.flags = flags;
	}
	protected int byteArrayToInt(byte[] bytes, int offset) {
		ByteBuffer bBuffer = ByteBuffer.wrap(bytes, offset, 4);
		IntBuffer lBuffer = bBuffer.asIntBuffer();
		return lBuffer.get();
	}

	protected long byteArrayToLong(byte[] bytes, int offset) {
		ByteBuffer bBuffer = ByteBuffer.wrap(bytes, offset, 8);
		LongBuffer lBuffer = bBuffer.asLongBuffer();
		return lBuffer.get();
	}

	protected byte[] intToByteArray(int l, int length) {
		byte[] bArray = new byte[4];
		ByteBuffer bBuffer = ByteBuffer.wrap(bArray);
		IntBuffer lBuffer = bBuffer.asIntBuffer();
		lBuffer.put(0, l);
		byte[] ret = new byte[length];
		for(int i = 0; i < length; i++) ret[i] = bArray[4 - length + i];
		return ret;
	}

	protected byte[] longToByteArray(long l, int length) {
		byte[] bArray = new byte[length];
		ByteBuffer bBuffer = ByteBuffer.wrap(bArray);
		LongBuffer lBuffer = bBuffer.asLongBuffer();
		lBuffer.put(0, l);
		byte[] ret = new byte[length];
		for(int i = 0; i < length; i++) ret[i] = bArray[8 - length + i];
		return ret;
	}

	protected byte[] booleanArrayToByteArray(boolean[] bArray) {
		byte[] ret;
		double temp = 0;
		for(int i = 0; i < bArray.length; i++) {
			if(bArray[i]) temp += Math.pow(2, (bArray.length-1 - i));
		}
		ret = this.intToByteArray((int) temp, 1);
		return ret;
	}
	
	protected void byteArrayToBooleanArray(byte[] bytes, int offset) { 
		String bitFlags = Integer.toBinaryString(new Byte(bytes[offset]).intValue());
		int index = bitFlags.length()-1;
		if(index < 8) for(int k = bitFlags.length(); k < 8; k++) flags[k] = false;
		while(index >= 0) {
			if(bitFlags.charAt(index) == '0') flags[(8-bitFlags.length()) + index] = false;
			else if(bitFlags.charAt(index) == '1') flags[(8-bitFlags.length()) + index] = true;
			index--;
		}
	}
}
