package basica;

import java.io.*;
import java.nio.*;

/* |<1 byte>|<1 byte>|<1 byte>|<1 byte>|
 *  ___________________________________
 * |        seqNumber (4 bytes)        |
 * |-----------------------------------|
 * |             timeStamp             |
 * |             (8 bytes)             |
 * |-----------------------------------|
 * | Flags  |                          |
 *  
 * 
 * 
 * Resto = dados.
 * 
 * +Flags (1 byte) = ?
 * Total = 13 bytes.
 */

public class PacketAudio extends Packet {
	int seqNum;
	long timeStp;
	//boolean flags[];
	ByteArrayOutputStream data;

	public PacketAudio() {
		flags = new boolean[8];
		data = new ByteArrayOutputStream();
	}

	public PacketAudio(int seqNum, boolean flags[], ByteArrayOutputStream data) {
		this.seqNum = seqNum;
		this.flags = flags;
		this.data = data;
	}

	public byte[] convertToByte() {
		byte[] seqNumByte = intToByteArray(seqNum, 4);
		this.timeStp = System.currentTimeMillis();
		byte[] timeStpByte = longToByteArray(timeStp, 8);
		byte[] flagsByte = booleanArrayToByteArray(flags);
		byte[] dataByte = null;
		int dataByteLength = 0;
		if(data != null) {
			dataByte = data.toByteArray();
			dataByteLength = dataByte.length;
		}
		byte[] ret = new byte[seqNumByte.length + timeStpByte.length + flagsByte.length + dataByteLength];
		int qtd = 0;
		System.arraycopy(seqNumByte, 0, ret, 0, seqNumByte.length);
		qtd += seqNumByte.length;
		System.arraycopy(timeStpByte, 0, ret, qtd, timeStpByte.length);
		qtd += timeStpByte.length;
		System.arraycopy(flagsByte, 0, ret, qtd, flagsByte.length);
		qtd += flagsByte.length;
		if(data != null) System.arraycopy(dataByte, 0, ret, qtd, dataByteLength);
		return ret;
	}

	public void bytesToPacket(byte[] pkt) {
		seqNum = byteArrayToInt(pkt, 0);
		timeStp = byteArrayToLong(pkt, 4);
		byteArrayToBooleanArray(pkt, 12);
		if(pkt.length > 13) data.write(pkt, 13, pkt.length - 13);
		else data = null;
	}
	
	public static void main(String args[]) {
		boolean[] b = {false, false, true, true, true, false, false, true};
		PacketAudio pkt = new PacketAudio(512, b, null);

		byte[] bytes = pkt.convertToByte();

		System.out.println("seqNum = "+pkt.seqNum+" | timeStp = "+pkt.timeStp);
		for(int i = 0; i < pkt.flags.length; i++) System.out.println("Flag n"+i+" = "+pkt.flags[i]);
		for(int i = 0; i < bytes.length; i++) System.out.println("Bytes["+i+"] = "+bytes[i]);

		System.out.println("length do bytes = "+bytes.length);

		pkt.bytesToPacket(bytes);
		System.out.println("seqNum = "+pkt.seqNum+" | timeStp = "+pkt.timeStp);
		for(int i = 0; i < pkt.flags.length; i++) System.out.println("Flag n"+i+" = "+pkt.flags[i]);
	}

	public int getSeqNum() {
		return seqNum;
	}

	public void setSeqNum(int seqNum) {
		this.seqNum = seqNum;
	}

	public long getTimeStp() {
		return timeStp;
	}

	public void setTimeStp(long timeStp) {
		this.timeStp = timeStp;
	}

	public ByteArrayOutputStream getData() {
		return data;
	}

	public void setData(ByteArrayOutputStream data) {
		this.data = data;
	}
}
