package basica;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.SourceDataLine;


public class PlayThread extends Thread{
	AudioFormat audioFormat;
	AudioInputStream audioInputStream;
	SourceDataLine sourceDataLine;
	byte tempBuffer[] = new byte[10000];

	public PlayThread(AudioFormat aF, AudioInputStream aIS, SourceDataLine src) {
		this.audioFormat = aF;
		this.audioInputStream = aIS;
		this.sourceDataLine = src;
	}
	public void run(){
		try{
			int cnt;
			//Keep looping until the input
			// read method returns -1 for
			// empty stream.
			while((cnt = audioInputStream.read(tempBuffer, 0,tempBuffer.length)) != -1){
				if(cnt > 0){
					//Write data to the internal
					// buffer of the data line
					// where it will be delivered
					// to the speaker.
					sourceDataLine.write(tempBuffer, 0, cnt);
				}//end if
			}//end while
			//Block and wait for internal
			// buffer of the data line to
			// empty.
			sourceDataLine.drain();
			sourceDataLine.close();
		}catch (Exception e) {
			System.out.println(e);
			System.exit(0);
		}//end catch
	}//end run
}//end inner class PlayThread