package udp;

import java.io.*;
import java.net.*;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.TargetDataLine;

import basica.CaptureThread;
import basica.PacketAudio;



public class EmissorUDP extends Thread implements Runnable{

	DatagramSocket socketUDP;
	InetAddress ip;
	int portaUDP;
	byte[] dadosUDP;
	AudioFormat audioFormat;
	TargetDataLine targetDataLine;
	int seqNum = 0;

	CaptureThread captureThread;
	boolean stop;

	public EmissorUDP(DatagramSocket UDP, InetAddress ip,int pUDP) {
		this.socketUDP = UDP;
		this.ip = ip;
		this.portaUDP = pUDP;
	}

	public void run() {

		try {
			//Get everything set up for
			// capture
			audioFormat = getAudioFormat();
			DataLine.Info dataLineInfo = new DataLine.Info(TargetDataLine.class, audioFormat);
			targetDataLine = (TargetDataLine)
			AudioSystem.getLine(dataLineInfo);
			targetDataLine.open(audioFormat);
			targetDataLine.start();

			//Create a thread to capture the
			// microphone data and start it
			// running.  It will run until
			// the Stop button is clicked.
			captureThread = new CaptureThread(targetDataLine);
			captureThread.start();
			
			PacketAudio pacote;
			DatagramPacket packet;

			stop = false;
			while(!stop) {
				boolean[] flags = new boolean[]{false, false, false, false, false, false, false, false};
				//while(captureThread.byteArrayOutputStream == null);
				sleep(20);
				pacote = new PacketAudio(seqNum++, flags, captureThread.getByteArrayOutputStream());
				captureThread.getByteArrayOutputStream().reset();
				this.dadosUDP = pacote.convertToByte();			
				packet = new DatagramPacket(dadosUDP, dadosUDP.length, this.ip, this.portaUDP);
				socketUDP.send(packet);
			}
			//quando parar o while, manda parar a captura de som tambm
			//mas e o targetDataLine, faz oq?
			targetDataLine.stop();
			captureThread.setStopCapture(true);

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch(InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println(e);
			System.exit(0);
		}//end catch*/
	}

	private AudioFormat getAudioFormat(){
		float sampleRate = 8000.0F;
		//8000,11025,16000,22050,44100
		int sampleSizeInBits = 16;
		//8,16
		int channels = 1;
		//1,2
		boolean signed = true;
		//true,false
		boolean bigEndian = false;
		//true,false
		return new AudioFormat(sampleRate,sampleSizeInBits,channels,signed,bigEndian);
	}//end getAudioFormat
//	===================================//
}
