package udp;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.*;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.SourceDataLine;

import basica.PacketAudio;
import basica.PlayThread;



public class ReceptorUDP extends Thread implements Runnable {

	DatagramSocket socketUDP;
	byte[] dadosUDP;
	PacketAudio pacoteUDP;
	ByteArrayOutputStream byteArrayOutputStream;
	AudioInputStream audioInputStream;
	SourceDataLine sourceDataLine;

	boolean stop;

	public ReceptorUDP(DatagramSocket udp, int tamanhoPacote) { 
		this.socketUDP = udp;
		this.dadosUDP = new byte[tamanhoPacote];
		
	}
	public void run() {
		DatagramPacket datagrama = new DatagramPacket(dadosUDP, dadosUDP.length);
		try {
			socketUDP.receive(datagrama);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		stop = false;
		try{
			pacoteUDP = new PacketAudio();
			byte audioData[];
			DatagramPacket receivePacket;
			AudioFormat audioFormat;
			InputStream byteArrayInputStream;
			DataLine.Info dataLineInfo;
			PlayThread playThread;
			
			while(!stop) {

				receivePacket = new DatagramPacket(dadosUDP, dadosUDP.length);
				socketUDP.receive(receivePacket);
				//traduz os bytes para informaes legveis
				pacoteUDP.bytesToPacket(receivePacket.getData());

				//Get everything set up for
				// playback.
				//Get the previously-saved data
				// into a byte array object.

				audioData = pacoteUDP.getData().toByteArray();

				//Get an input stream on the
				// byte array containing the data
				byteArrayInputStream = new ByteArrayInputStream(audioData);
				audioFormat = getAudioFormat();
				audioInputStream = new AudioInputStream(byteArrayInputStream,audioFormat,audioData.length/audioFormat.getFrameSize());
				dataLineInfo = new DataLine.Info(SourceDataLine.class,audioFormat);
				sourceDataLine = (SourceDataLine) AudioSystem.getLine(dataLineInfo);
				sourceDataLine.open(audioFormat);
				sourceDataLine.start();

				//Create a thread to play back
				// the data and start it
				// running.  It will run until
				// all the data has been played
				// back.
				playThread = new PlayThread(audioFormat, audioInputStream, sourceDataLine);
				playThread.start();
			}
		} catch (Exception e) {
			//TODO 
			System.out.println(e);
			System.exit(0);
		}//end catch
	}

	private AudioFormat getAudioFormat(){
		float sampleRate = 8000.0F;
		//8000,11025,16000,22050,44100
		int sampleSizeInBits = 16;
		//8,16
		int channels = 1;
		//1,2
		boolean signed = true;
		//true,false
		boolean bigEndian = false;
		//true,false
		return new AudioFormat(sampleRate,sampleSizeInBits,channels,signed,bigEndian);
	}//end getAudioFormat
//	===================================//
}
